## asis 3.12p

=== Makefile ===
include Makefile.stub

all: install ds gnatstub gnatelim

install:
	$(MAKE) -e -C obj install

ds:
	$(MAKE) -e -C examples/ds

gnatstub:
	$(MAKE) -e -C examples/gnatstub

gnatelim:
	$(MAKE) -e -C examples/gnatelim

clean:
	$(MAKE) -e -C obj clean
	$(MAKE) -e -C examples/ds clean
	$(MAKE) -e -C examples/gnatstub clean
	$(MAKE) -e -C asistant clean
	$(MAKE) -e -C examples/gnatelim clean

=== asistant/Makefile ===
include ../Makefile.stub
default:
	gnatmake $(GNATMAKE_FLAGS) -I$(INSTALL_DIR)/asis $(CFLAGS) \
	         asistant-driver -o asistant \
	         -cargs $(ADAFLAGS) -largs -lasis -lgnat
clean:
	$(RM) *$(objext)
	$(RM) *.ali
	$(RM) b_*.c
	$(RM) asistant$(exe_ext)
	$(RM) *~

=== obj/Makefile ===
include ../Makefile.stub
IDIR=$(INSTALL_DIR)/asis
install: libasis$(arext)
	$(RMDIR) $(IDIR)
	$(MKDIR) $(IDIR)
	$(INSTALL_FILES) *.ali $(IDIR)
	$(CHMOD) a-w $(IDIR)/*.ali
	$(INSTALL_FILES) *$(arext) $(IDIR)
	$(INSTALL_FILES) $(GNAT_DIR)/*.ads  $(GNAT_DIR)/*.adb $(IDIR)
	$(INSTALL_FILES) $(ASIS_DIR)/*.ads  $(ASIS_DIR)/*.adb $(IDIR)
	$(MAKE) -e -C ../asistant

libasis$(arext): bld-objs
	$(AR) $(AR_FLAGS) libasis$(arext) *$(objext)
ifneq "$(findstring OpenVMS, $(host))" "OpenVMS"
#	VMS doesn't understand Unix shell "if" commands
	if $(RANLIB_TEST) ; then $(RANLIB) libasis$(arext); else true; fi
endif

bld-objs:
	gnatmake -c $(GNATMAKE_FLAGS) -aI$(GNAT_DIR) -aI$(ASIS_DIR) $(CFLAGS)\
	         install_asis.adb \
                 -cargs $(ADAFLAGS)
	$(RM) install_asis$(objext) install_asis.ali

libasis$(soext): clean
	$(MAKE) -e bld-objs CFLAGS="$(CFLAGS) -fPIC"
	gcc -shared -o libasis$(soext) *$(objext)

clean:
	$(RM) *$(objext)
	$(RM) *.ali
	$(RM) *$(arext)
	$(RM) *$(soext)
	$(RM) *~

=== examples/ds/Makefile ===
include ../../Makefile.stub
default:
	gnatmake $(GNATMAKE_FLAGS) -I$(INSTALL_DIR)/asis $(CFLAGS) \
	         display_source -o ds \
	         -cargs $(ADAFLAGS) -largs -lasis -lgnat
clean:
	$(RM) *$(objext)
	$(RM) *.ali
	$(RM) b_*.c
	$(RM) ds$(exe_ext)

=== examples/gnatelim/Makefile ===
include ../../Makefile.stub
default:
	gnatmake $(GNATMAKE_FLAGS) -I$(INSTALL_DIR)/asis $(CFLAGS) \
	         gnatelim-driver -o gnatelim \
	         -cargs $(ADAFLAGS) -largs -lasis -lgnat
clean:
	$(RM) *$(objext)
	$(RM) *.ali
	$(RM) b_*.c
	$(RM) gnatelim$(exe_ext)

=== examples/gnatstub/Makefile ===
include ../../Makefile.stub
default:
	gnatmake $(GNATMAKE_FLAGS) -I$(INSTALL_DIR)/asis $(CFLAGS) \
	         gnatstub-driver -o gnatstub \
	         -cargs $(ADAFLAGS) -largs -lasis -lgnat
clean:
	$(RM) *$(objext)
	$(RM) *.ali
	$(RM) b_*.c
	$(RM) gnatstub$(exe_ext)

## asis 3.14p

=== Makefile ===
include Makefile.stub

all: install ds gnatstub gnatelim

install:
	$(MAKE) -e -C obj install

ds:
	$(MAKE) -e -C examples/ds

gnatstub:
	$(MAKE) -e -C tools/gnatstub

gnatelim:
	$(MAKE) -e -C tools/gnatelim

clean:
	$(MAKE) -e -C obj clean
	$(MAKE) -e -C examples/ds clean
	$(MAKE) -e -C tools/gnatstub clean
	$(MAKE) -e -C tools/asistant clean
	$(MAKE) -e -C tools/gnatelim clean

=== obj/Makefile ===
--- 
+++ 
@@ -8,7 +8,7 @@
 	$(INSTALL_FILES) *$(arext) $(IDIR)
 	$(INSTALL_FILES) $(GNAT_DIR)/*.ads  $(GNAT_DIR)/*.adb $(IDIR)
 	$(INSTALL_FILES) $(ASIS_DIR)/*.ads  $(ASIS_DIR)/*.adb $(IDIR)
-	$(MAKE) -e -C ../asistant
+	$(MAKE) -e -C ../tools/asistant
 
 libasis$(arext): bld-objs
 	$(AR) $(AR_FLAGS) libasis$(arext) *$(objext)
@@ -18,9 +18,15 @@
 endif
 
 bld-objs:
+	gcc -c $(GNATMAKE_FLAGS) -I$(GNAT_DIR) -I$(ASIS_DIR) install_asis.adb
+#	install_asis.adb is not '-gnatg-compilable'
+ifeq "$(findstring hppa, $(host))" "hppa"
+# this file has problems when compiled with optimization see 7418-013
+	gcc -c  -I$(GNAT_DIR)  $(CFLAGS) -O0 $(ASIS_DIR)/a4g-a_sinput.adb
+endif
 	gnatmake -c $(GNATMAKE_FLAGS) -aI$(GNAT_DIR) -aI$(ASIS_DIR) $(CFLAGS)\
 	         install_asis.adb \
-                 -cargs $(ADAFLAGS)
+                 -cargs $(ADA_FLAGS_FOR_ASISLIB)
 	$(RM) install_asis$(objext) install_asis.ali
 
 libasis$(soext): clean

=== tools/asistant/Makefile ===
include ../../Makefile.stub
default:
	gnatmake $(GNATMAKE_FLAGS) -I$(INSTALL_DIR)/asis $(CFLAGS) \
	         asistant-driver -o asistant \
                 -cargs $(ADA_FLAGS_FOR_TOOLS) -largs -lasis
clean:
	$(RM) *$(objext)
	$(RM) *.ali
	$(RM) b_*.c
	$(RM) asistant$(exe_ext)
	$(RM) *~

## asis 3.15p

=== Makefile ===


=== documentation/Makefile ===
all: ps html info partial_clean

ps:   asis_ug.ps   asis_rm.ps
html: asis_ug.html asis_rm.html
info: asis_ug.info asis_rm.info

asis_ug.ps asis_rm.ps :
	echo x | tex ${@:%.ps=%.texi}
	texindex ${@:%.ps=%.cp}
	tex ${@:%.ps=%.texi}
	dvips ${@:%.ps=%.dvi} -o $@

asis_ug.html asis_rm.html :
	texi2html -number ${@:%.html=%.texi}

asis_ug.info asis_rm.info :
	makeinfo --force -o $@ ${@:%.info=%.texi}
	makeinfo --force --no-headers --no-split -o ${@:%.info=%.txt} \
		${@:%.info=%.texi}

partial_clean:
	rm -f *.aux *.cp *.cps *.dvi *.fn *.ky *.log *.pg *.toc *.tp *.vr

clean: partial_clean
	rm -rf *.ps *.info* asis_rm.txt asis_ug.txt


asis_ug.ps : asis_ug.texi
asis_rm.ps : asis_rm.texi

asis_ug.html : asis_ug.texi
asis_rm.html : asis_rm.texi

asis_ug.info : asis_ug.texi
asis_rm.info : asis_rm.texi

=== obj/Makefile ===
--- 
+++ 
@@ -18,11 +18,11 @@
 endif
 
 bld-objs:
-	gcc -c $(GNATMAKE_FLAGS) -I$(GNAT_DIR) -I$(ASIS_DIR) install_asis.adb
+	$(CC) -c $(GNATMAKE_FLAGS) -I$(GNAT_DIR) -I$(ASIS_DIR) install_asis.adb
 #	install_asis.adb is not '-gnatg-compilable'
 ifeq "$(findstring hppa, $(host))" "hppa"
 # this file has problems when compiled with optimization see 7418-013
-	gcc -c  -I$(GNAT_DIR)  $(CFLAGS) -O0 $(ASIS_DIR)/a4g-a_sinput.adb
+	$(CC) -c  -I$(GNAT_DIR)  $(CFLAGS) -O0 $(ASIS_DIR)/a4g-a_sinput.adb
 endif
 	gnatmake -c $(GNATMAKE_FLAGS) -aI$(GNAT_DIR) -aI$(ASIS_DIR) $(CFLAGS)\
 	         install_asis.adb \
@@ -31,7 +31,7 @@
 
 libasis$(soext): clean
 	$(MAKE) -e bld-objs CFLAGS="$(CFLAGS) -fPIC"
-	gcc -shared -o libasis$(soext) *$(objext)
+	$(CC) -shared -o libasis$(soext) *$(objext)
 
 clean:
 	$(RM) *$(objext)

=== tools/gnatelim/Makefile ===
include ../../Makefile.stub
# Compile this tool statically so that it can be distributed easily with
# GNAT
default:
	gnatmake $(GNATMAKE_FLAGS) -I$(INSTALL_DIR)/asis $(CFLAGS) \
	         gnatelim-driver -o gnatelim \
                 -cargs $(ADA_FLAGS_FOR_TOOLS) -bargs -static -largs -lasis
clean:
	$(RM) *$(objext)
	$(RM) *.ali
	$(RM) b_*.c
	$(RM) gnatelim$(exe_ext)

=== tools/gnatstub/Makefile ===
include ../../Makefile.stub
# Compile this tool statically so that it can be distributed easily with
# GNAT
default:
	gnatmake $(GNATMAKE_FLAGS) -I$(INSTALL_DIR)/asis $(CFLAGS) \
	         gnatstub-driver -o gnatstub \
                 -cargs $(ADA_FLAGS_FOR_TOOLS) -bargs -static -largs -lasis
clean:
	$(RM) *$(objext)
	$(RM) *.ali
	$(RM) b_*.c
	$(RM) gnatstub$(exe_ext)

## asis 2005

=== Makefile ===
include Makefile.stub

all: install install-asistant install-tools

BLD=prod
IDIR=$(INSTALL_DIR)/lib/gnat/asis
tools = gnatstub gnatelim gnatmetric gnatpp

install: lib/libasis$(arext)
	$(RMDIR) $(IDIR)
	$(MKDIR) $(IDIR)/obj
	$(MKDIR) $(IDIR)/src
	$(MKDIR) $(IDIR)/lib
	$(INSTALL_FILES) lib/*.ali $(IDIR)/obj
	$(CHMOD) a-w $(IDIR)/obj/*.ali
	$(INSTALL_FILES) lib/libasis$(arext) $(IDIR)/lib
	$(CHMOD) a-w $(IDIR)/lib/libasis$(arext)
	$(INSTALL_FILES) gnat/*.ads  gnat/*.adb $(IDIR)/src
	$(INSTALL_FILES) asis/*.ads  asis/*.adb $(IDIR)/src
	$(INSTALL_FILES) asis/asis.gpr $(IDIR)/..

lib/libasis$(arext): force
	gnat make -Pasis_bld -XBLD=$(BLD) -XOPSYS=$(OPSYS)

install-tools: $(tools:%=install-%)
	echo $<

gnat%:
	gnatmake "-Ptools/$@/$@" "-XBLD=$(BLD)" "-XOPSYS=$(OPSYS)"

asistant:
	gnatmake "-Ptools/$@/$@" "-XBLD=$(BLD)" "-XOPSYS=$(OPSYS)"

install-asistant: asistant
	$(INSTALL_FILES) tools/asistant/asistant$(exe_ext)\
	                 $(INSTALL_DIR)/bin

install-gnat%: gnat%
	$(INSTALL_FILES) tools/gnat$*/gnat$*$(exe_ext)\
	                 $(INSTALL_DIR)/bin
atre:
	gnat make -Ptools/$@/$@

clean-gnat%:
	gnat clean -Ptools/gnat$*/gnat$*

clean: clean-gnatstub clean-gnatelim clean-gnatpp clean-gnatmetric
	gnat clean -Pasis_bld

force:

=== obj/Makefile ===
--- 
+++ 
@@ -12,7 +12,7 @@
 
 libasis$(arext): bld-objs
 	$(AR) $(AR_FLAGS) libasis$(arext) *$(objext)
-ifneq "$(findstring OpenVMS, $(host))" "OpenVMS"
+ifneq ($(strip $(filter-out OpenVMS% openvms%, $(host))),)
 #	VMS doesn't understand Unix shell "if" commands
 	if $(RANLIB_TEST) ; then $(RANLIB) libasis$(arext); else true; fi
 endif

=== examples/ds/Makefile ===
include ../../Makefile.stub
default:
	gnatmake $(GNATMAKE_FLAGS) -I$(INSTALL_DIR)/asis $(CFLAGS) \
	         display_source -o ds \
                 -cargs $(ADA_FLAGS_FOR_TOOLS) -largs -lasis
clean:
	$(RM) *$(objext)
	$(RM) *.ali
	$(RM) b_*.c
	$(RM) ds$(exe_ext)

=== tools/asistant/Makefile ===
include ../../Makefile.stub
BLD=prod

default:
	gnat make -Pasistant -XBld=$(BLD)
clean:
	gnat clean -Pasistant

=== tools/gnatelim/Makefile ===
include ../../Makefile.stub
BLD=prod

default:
	gnat make -Pgnatelim -XBld=$(BLD)
clean:
	gnat clean -Pgnatelim

=== tools/gnatmetric/Makefile ===
include ../../Makefile.stub
BLD=prod

default:
	gnat make -Pgnatmetric -XBld=$(BLD)
clean:
	gnat clean -Pgnatmetric

=== tools/gnatpp/Makefile ===
include ../../Makefile.stub
BLD=prod

default:
	gnat make -Pgnatpp -XBld=$(BLD)
clean:
	gnat clean -Pgnatpp

=== tools/gnatstub/Makefile ===
include ../../Makefile.stub
BLD=prod

default:
	gnat make -Pgnatstub -XBld=$(BLD)
clean:
	gnat clean -Pgnatstub

## asis 2007

=== Makefile ===

include Makefile.stub

all: install install-asistant install-tools

BLD=prod
tools = gnatstub gnatelim gnatmetric gnatpp gnatcheck

I_BIN	= $(INSTALL_DIR)/bin
I_INC	= $(INSTALL_DIR)/include/asis
I_LIB	= $(INSTALL_DIR)/lib/asis
I_GPR	= $(INSTALL_DIR)/lib/gnat
I_DOC   = $(INSTALL_DIR)/share/doc/asis
I_GPS   = $(INSTALL_DIR)/share/gps/plug-ins

install: lib/libasis$(arext)
	$(RMDIR) $(I_INC)
	$(RMDIR) $(I_LIB)
	$(MKDIR) $(I_BIN)
	$(MKDIR) $(I_INC)
	$(MKDIR) $(I_LIB)
	$(MKDIR) $(I_GPR)
	$(MKDIR) $(I_GPS)
	$(MKDIR) $(I_DOC)/html
	$(MKDIR) $(I_DOC)/info
	$(MKDIR) $(I_DOC)/pdf
	$(INSTALL_FILES) lib/*.ali $(I_LIB)
	$(CHMOD) a-w $(I_LIB)/*.ali
	$(INSTALL_FILES) lib/libasis$(arext) $(I_LIB)
	$(CHMOD) a-w $(I_LIB)/libasis$(arext)
	$(INSTALL_FILES) gnat/*.ads gnat/*.adb $(I_INC)
	$(INSTALL_FILES) asis/*.ads asis/*.adb $(I_INC)
	$(INSTALL_FILES) asis/asis.gpr $(I_GPR)
	$(INSTALL_FILES) documentation/*.html $(I_DOC)/html/
	$(INSTALL_FILES) documentation/*.pdf  $(I_DOC)/pdf/
	$(INSTALL_FILES) documentation/*.info $(I_DOC)/info/
	$(INSTALL_FILES) documentation/gps_index.xml $(I_GPS)/asis.xml

lib/libasis$(arext): force
	gnat make -Pasis_bld -XBLD=$(BLD) -XOPSYS=$(OPSYS)

install-tools: $(tools:%=install-%)
	echo $<

gnat%:
	gnatmake "-Ptools/$@/$@" "-XBLD=$(BLD)" "-XOPSYS=$(OPSYS)"

asistant:
	gnatmake "-Ptools/$@/$@" "-XBLD=$(BLD)" "-XOPSYS=$(OPSYS)"

install-asistant: asistant
	$(MKDIR) $(I_BIN)
	$(INSTALL_FILES) tools/asistant/asistant$(exe_ext) $(I_BIN)

install-gnat%: gnat%
	$(MKDIR) $(I_BIN)
	$(INSTALL_FILES) tools/gnat$*/gnat$*$(exe_ext) $(I_BIN)
atre:
	gnat make -Ptools/$@/$@

clean-gnat%:
	gnat clean -Ptools/gnat$*/gnat$*

clean: clean-gnatstub clean-gnatelim clean-gnatpp clean-gnatmetric
	gnat clean -Pasis_bld

force:

=== tools/gnatcheck/Makefile ===
include ../../Makefile.stub
BLD=prod

default:
	gnat make -Pgnatcheck -XBld=$(BLD)
clean:
	gnat clean -Pgnatcheck

## asis 2008

=== Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 
 include Makefile.stub
 
-all: install install-asistant install-tools
+all: install install-asistant
 
 BLD=prod
 tools = gnatstub gnatelim gnatmetric gnatpp gnatcheck
@@ -37,16 +37,16 @@
 	$(INSTALL_FILES) documentation/gps_index.xml $(I_GPS)/asis.xml
 
 lib/libasis$(arext): force
-	gnat make -Pasis_bld -XBLD=$(BLD) -XOPSYS=$(OPSYS)
+	$(GNATMAKE) -Pasis_bld -XBLD=$(BLD) -XOPSYS=$(OPSYS)
 
 install-tools: $(tools:%=install-%)
 	echo $<
 
 gnat%:
-	gnatmake "-Ptools/$@/$@" "-XBLD=$(BLD)" "-XOPSYS=$(OPSYS)"
+	$(GNATMAKE) "-Ptools/$@/$@" "-XBLD=$(BLD)" "-XOPSYS=$(OPSYS)"
 
 asistant:
-	gnatmake "-Ptools/$@/$@" "-XBLD=$(BLD)" "-XOPSYS=$(OPSYS)"
+	$(GNATMAKE) "-Ptools/$@/$@" "-XBLD=$(BLD)" "-XOPSYS=$(OPSYS)"
 
 install-asistant: asistant
 	$(MKDIR) $(I_BIN)

=== documentation/Makefile ===
all: pdf html info partial_clean

pdf:  asis_ug.pdf  asis_rm.pdf
html: asis_ug.html asis_rm.html
info: asis_ug.info asis_rm.info

asis_ug.pdf asis_rm.pdf :
	echo x | texi2pdf ${@:%.pdf=%.texi}

asis_ug.html asis_rm.html :
	texi2html -split chapter -number -subdir=. ${@:%.html=%.texi}

asis_ug.info asis_rm.info :
	makeinfo --force --no-split -o $@ ${@:%.info=%.texi}
	makeinfo --force --no-headers --no-split -o ${@:%.info=%.txt} \
		${@:%.info=%.texi}

partial_clean:
	rm -f *.aux *.cp *.cps *.dvi *.fn *.ky *.log *.pg *.toc *.tp *.vr

clean: partial_clean
	rm -rf *.ps *.info* *.html asis_rm.txt asis_ug.txt


asis_ug.pdf : asis_ug.texi
asis_rm.pdf : asis_rm.texi

asis_ug.html : asis_ug.texi
asis_rm.html : asis_rm.texi

asis_ug.info : asis_ug.texi
asis_rm.info : asis_rm.texi

asis_ug.texi: edition.texi texinfo.tex texiplus.tex
asis_rm.texi: edition.texi texinfo.tex texiplus.tex

edition.texi:
	cp ../gnat/edition.texi .

texinfo.tex:
	cp ../gnat/texinfo.tex .

texiplus.tex:
	cp ../gnat/texiplus.tex .

=== obj/Makefile ===
--- 
+++ 
@@ -24,8 +24,8 @@
 # this file has problems when compiled with optimization see 7418-013
 	$(CC) -c  -I$(GNAT_DIR)  $(CFLAGS) -O0 $(ASIS_DIR)/a4g-a_sinput.adb
 endif
-	gnatmake -c $(GNATMAKE_FLAGS) -aI$(GNAT_DIR) -aI$(ASIS_DIR) $(CFLAGS)\
-	         install_asis.adb \
+	$(GNATMAKE) -c $(GNATMAKE_FLAGS) -aI$(GNAT_DIR) -aI$(ASIS_DIR) \
+		 $(CFLAGS) install_asis.adb \
                  -cargs $(ADA_FLAGS_FOR_ASISLIB)
 	$(RM) install_asis$(objext) install_asis.ali

## asis 2010

=== Makefile ===

include Makefile.stub

all: lib/libasis$(arext) asistant

BLD=prod
tools = gnatstub gnatelim gnatmetric gnatpp gnatcheck

I_BIN	= $(prefix)/bin
I_INC	= $(prefix)/include/asis
I_LIB	= $(prefix)/lib/asis
I_GPR	= $(prefix)/lib/gnat
I_DOC   = $(prefix)/share/doc/asis
I_GPS   = $(prefix)/share/gps/plug-ins
G_DOC   = $(prefix)/share/doc/gnat

install: install-lib install-asistant

install-lib:
	$(RMDIR) $(I_INC)
	$(RMDIR) $(I_LIB)
	$(MKDIR) $(I_BIN)
	$(MKDIR) $(I_INC)
	$(MKDIR) $(I_LIB)
	$(MKDIR) $(I_GPR)
	$(MKDIR) $(I_GPS)
	$(MKDIR) $(I_DOC)/html
	$(MKDIR) $(I_DOC)/info
	$(MKDIR) $(I_DOC)/pdf
	$(INSTALL_FILES) lib/*.ali $(I_LIB)
	$(CHMOD) a-w $(I_LIB)/*.ali
	$(INSTALL_FILES) lib/libasis$(arext) $(I_LIB)
	$(CHMOD) a-w $(I_LIB)/libasis$(arext)
ifneq ($(ATTRIB),)
	cd $(I_LIB) && $(ATTRIB) +r '*.ali'
	cd $(I_LIB) && $(ATTRIB) +r 'libasis$(arext)'
endif
	$(INSTALL_FILES) gnat/*.ads gnat/*.adb $(I_INC)
	$(INSTALL_FILES) asis/*.ads asis/*.adb $(I_INC)
	$(INSTALL_FILES) asis/asis.gpr $(I_GPR)
	$(INSTALL_FILES) documentation/gps_index.xml $(I_GPS)/asis.xml
	-$(INSTALL_FILES) documentation/asis_*.html $(I_DOC)/html/
	-$(INSTALL_FILES) documentation/asis_*.pdf  $(I_DOC)/pdf/
	-$(INSTALL_FILES) documentation/asis_*.info $(I_DOC)/info/

lib/libasis$(arext): force
	cd gnat && $(GNATMAKE) xsnamest && ./xsnamest \
		&& mv snames.ns snames.ads && mv snames.nb snames.adb
	$(GNATMAKE) -Pasis_bld -XBLD=$(BLD) -XOPSYS=$(OPSYS)

install-tools: $(tools:%=install-%)
	echo $<

gnat%:
	$(GNATMAKE) "-Ptools/$@/$@" "-XBLD=$(BLD)" "-XOPSYS=$(OPSYS)"

tools: $(tools)

asistant:
	$(GNATMAKE) "-Ptools/$@/$@" "-XBLD=$(BLD)" "-XOPSYS=$(OPSYS)"

install-asistant:
	$(MKDIR) $(I_BIN)
	$(INSTALL_FILES) tools/asistant/asistant$(exe_ext) $(I_BIN)

install-gnat%: gnat%
	$(MKDIR) $(I_BIN)
	$(INSTALL_FILES) tools/gnat$*/gnat$*$(exe_ext) $(I_BIN)

install-gnatcheck-doc:
	$(MKDIR) $(G_DOC)/html
	$(MKDIR) $(G_DOC)/info
	$(MKDIR) $(G_DOC)/pdf
	$(MKDIR) $(G_DOC)/txt
	$(INSTALL_FILES) documentation/gnatcheck_rm.pdf  $(G_DOC)/pdf/
	$(INSTALL_FILES) documentation/gnatcheck_rm*.html $(G_DOC)/html/
	$(INSTALL_FILES) documentation/gnatcheck_rm.info $(G_DOC)/info/
	$(INSTALL_FILES) documentation/gnatcheck_rm.txt $(G_DOC)/txt/

atre:
	gnat make -Ptools/$@/$@

clean-gnat%:
	gnat clean -Ptools/gnat$*/gnat$*

clean: clean-gnatstub clean-gnatelim clean-gnatpp clean-gnatmetric clean-gnatcheck
	gnat clean -Pasis_bld

force:

=== documentation/Makefile ===
all: pdf html info partial_clean

pdf:  asis_ug.pdf  asis_rm.pdf gnatcheck_rm.pdf
html: asis_ug.html asis_rm.html gnatcheck_rm.html
info: asis_ug.info asis_rm.info gnatcheck_rm.info

partial_clean:
	rm -f *.aux *.cp *.cps *.dvi *.fn *.ky *.log *.pg *.toc *.tp *.vr

clean: partial_clean
	rm -rf *.ps *.info* *.html asis_rm.txt asis_ug.txt

%.pdf: %.texi
	echo x | texi2pdf ${@:%.pdf=%.texi}

%.html: %.texi
	texi2html -split chapter -number -subdir=. ${@:%.html=%.texi}

%.info: %.texi
	makeinfo --force --no-split -o $@ ${@:%.info=%.texi}
	makeinfo --force --no-headers --no-split -o ${@:%.info=%.txt} \
		${@:%.info=%.texi}

asis_ug.texi: edition.texi texinfo.tex texiplus.tex gfdl.texi
asis_rm.texi: edition.texi texinfo.tex texiplus.tex gfdl.texi
gnatcheck_rm.texi: edition.texi texinfo.tex texiplus.tex gfdl.texi
	cp ../tools/gnatcheck/gnatcheck_rm.texi .

gfdl.texi:
	cp ../gnat/gfdl.texi .

edition.texi:
	cp ../gnat/edition.texi .

texinfo.tex:
	cp ../gnat/texinfo.tex .

texiplus.tex:
	cp ../gnat/texiplus.tex .

gnatcheck_rules.texi : ../tools/gnatcheck/gnatcheck-docgen
	(cd ../tools/gnatcheck; ./gnatcheck-docgen$(exe_ext))
	cp ../tools/gnatcheck/docs/gnatcheck_rules.texi .

../tools/gnatcheck/gnatcheck-docgen :
	(cd ../tools/gnatcheck; gnatmake -Pgnatcheck gnatcheck-docgen)

=== tools/gnatpp/Makefile ===
include ../../Makefile.stub
BLD=prod

default:
	gnat make -Pgnatpp -XBLD=$(BLD)
clean:
	gnat clean -Pgnatpp

=== debian/changelog ===
asis (2010-6) unstable; urgency=low

  * Switch to dpkg-source 3.0 (quilt) format.
  * Uploaders += myself, removed obsolete DM-Upload-Allowed for Xavier.
  * Rely on dpkg-dev and dh-ada-library for (hardening) flags.
    Actually set library_kind when building tools.
    Let gnatmake decide if recompilation is needed.
    Do not set ALI files read-only (dh_fixperms handles this now).
  * Switch to debhelper 9. Readers now handle compressed pdf.
    Install README only once (in asis-doc).
  * Switch to dh-ada-library. -dbg is now Multi-Arch: same.
  * rules, *.gpr: consistent naming for persistent obj directories.
  * Lintian: GFDL is mentioned in the patch removing it. Closes: #708779.
    -dbg->lib dependency is generated in ada:Depends, not forgotten.
  * copyright: adapt to the machine-readable format 1.0.
  * Minimal link-with-shared test.
  * Doc-base registration. Use texi2any instead of texi2html. Ignore texiplus.
  * control: Standards-Version: 3.9.4. VCS-*. Homepage. Commented watch file.
  * Replace - with \- in manpages.
  * patches: refreshed without timestamps.
  * Avoid duplicate installed README files. Avoid duplicate cleaning recipes.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sat, 14 Sep 2013 08:52:50 +0200

asis (2010-5) unstable; urgency=low

  * debian/rules: use wildcards in lintian overrides to make them
    arch-independent.  Closes: #677155 and special thanks to Jakub Wilk
    for reporting the bug so quickly and suggesting this solution.

 -- Ludovic Brenta <lbrenta@debian.org>  Tue, 12 Jun 2012 08:52:50 +0200

asis (2010-4) unstable; urgency=low

  * debian/tools.gpr, debian/rules: correct the way we build the tools;
    each tool contains a different copy of some units, so the project file
    must reference only the source directory of the tool being built.
    Closes: #676338.
  * debian/control: do not reference ada-compiler anymore, per
    https://lists.debian.org/debian-ada/2011/12/msg00012.html.
    (Standards-Version): bump to 3.9.3 with no changes required.
  * debian/rules: generate Lintian overrides for all packages for warnings
    hardening-no-relro and hardening-no-fortify-functions, which do not
    apply to Ada.

 -- Ludovic Brenta <lbrenta@debian.org>  Sun, 10 Jun 2012 21:49:21 +0200

asis (2010-3) unstable; urgency=low

  * debian/install_asis.gpr: work around compiler bug #642980 by
    compiling asis-text.adb without optimization.  Fixes FTBFS on
    kfreebsd-amd64, mips and mipsel.

 -- Ludovic Brenta <lbrenta@debian.org>  Sat,  1 Oct 2011 19:20:55 +0200

asis (2010-2) unstable; urgency=low

  * debian/rules (binary-arch, binary-indep): apply patches before
    building.  Fixes FTBFS when building with dpkg-buildpackage -b.

 -- Ludovic Brenta <lbrenta@debian.org>  Wed,  7 Sep 2011 01:19:06 +0200

asis (2010-1) unstable; urgency=low

  [Xavier Grave]
  * New upstream version 2010 GPL
  * Migrate to gnat-4.6.
  * Add get-orig-source in debian/rules
  * Package renamings pursuant to the Debian Policy for Ada:
    libasis2008-dev  -> libasis2010-dev
    libasis2008      -> libasis2010
    libasis2008-dbg  -> libasis2010-dbg

  [Ludovic Brenta]
  * debian/control (Architectures): any.
    (Uploaders): add Xavier Grave.
    (DM-Upload-Allowed): yes.
    (Build-Depends-Indep): new.
    (Standards-Version): bump to 3.9.2 with no changes required.
    (libasis2010): Multiarch: same.
  * debian/compat: bump from 7 to 8.    
  * debian/rules (build): split into build-arch and build-indep.
    (build-indep, clean): build the documentation from source instead of
    shipping upstream's prebuilt doc (which we exclude from the orig
    tarball).
    (libasis2010, libasis2010-dev, libasis2020-dbg): move the shared library
    to the multiarch-compliant directory.
    (libasis2010-dev): Move the examples and tutorial to...
    (asis-doc): ... here.
  * debian/patches/info.patch: remove.
  * debian/patches/documentation.patch: new.
    (documentation/*.texi): clarify that the license of the documentation is
    GPLv2 or later, like the rest of the sources, as opposed to GFDL.
    (documentation/*.texi) add stanzas to place the documentation under "GNU
    Ada Tools" in the top-level info menu.
    (Makefile): use the system-provided texinfo.tex instead of the one
    bundled with the sources.
    (documentation/edition.texi): change to FSFEDITION.
    (documentation/version.texi): change to 4.6.

 -- Ludovic Brenta <lbrenta@debian.org>  Tue,  6 Sep 2011 10:25:46 +0200

asis (2008-5) unstable; urgency=low

  Comply with Debian Policy for Ada, Fifth Edition:
  * debian/control (libasis2008-dev):
    - Suggest the -dbg package.
    (libasis2008-dev, asis-programs, libasis2008): Depend on
    ada-compiler in addition to gnat.
    (libasis2008-dbg, libasis-doc): Suggest ada-compiler and gnat.

 -- Ludovic Brenta <lbrenta@debian.org>  Sat, 29 May 2010 20:56:26 +0200

asis (2008-4) unstable; urgency=low

  * debian/control (libasis2008): depend on gnat (closes: #572359)
    and gnat-4.4 (closes: #565619).
    (Architecture): add armel.  Closes: #568435.
  * debian/rules (asis-doc): install a few additional doc files.

 -- Ludovic Brenta <lbrenta@debian.org>  Thu, 11 Mar 2010 18:37:40 +0100

asis (2008-3) unstable; urgency=low

  * debian/control (Architecture): really disable alpha.
    (asis-doc): correct the short description.

 -- Ludovic Brenta <lbrenta@debian.org>  Tue, 24 Nov 2009 00:46:47 +0100

asis (2008-2) unstable; urgency=low

  * debian/control (Architecture): temporarily disable alpha due to
    http://gcc.gnu.org/PR42073.

 -- Ludovic Brenta <lbrenta@debian.org>  Thu, 19 Nov 2009 22:16:58 +0100

asis (2008-1) unstable; urgency=low

  * New upstream version, roughly corresponding to gnat-4.4.
  * debian/control (libasis-dev): rename to libasis2008-dev, with
    Conflicts: and Replaces:, per Debian Policy for Ada
    [http://people.debian.org/~lbrenta/debian-ada-policy.html]
    (libasis2007.1): rename to libasis2008 with soname bump.


=== debian/control ===
Source: asis
Maintainer: Ludovic Brenta <lbrenta@debian.org>
Uploaders: Xavier Grave <xavier.grave@ipno.in2p3.fr>,
 Nicolas Boulenguez <nicolas@debian.org>
Section: libdevel
Priority: optional
Standards-Version: 3.9.4
Build-Depends: dpkg-dev (>= 1.16.1), debhelper (>= 9),
 gnat, gnat-4.6, dh-ada-library,
 libgnatvsn4.6-dev
Build-Depends-Indep: texinfo, texlive-generic-recommended,
 texlive-fonts-recommended, texlive-latex-base
Vcs-Browser: http://www.ada-france.org:8081/branch/changes/org.debian.asis
Vcs-Mtn: www.ada-france.org org.debian.asis
Homepage: http://libre.adacore.com/libre/tools
XS-Testsuite: autopkgtest

Package: libasis2010-dev
Architecture: any
Conflicts: libasis-3.15p-1-dev, libasis-dev, libasis2008-dev
Replaces: libasis-dev
Depends: ${ada:Depends}, ${misc:Depends}
Suggests: libasis-doc, libasis2010-dbg
Description: Ada Semantic Interface Specification (ASIS) headers and libraries
 ASIS (Ada Semantic Interface Specification) lets you develop applications
 to walk through the sources of your Ada programs and examine the semantic
 constructs.
 .
 This package lets you build ASIS applications with GNAT.

Package: asis-programs
Architecture: any
Section: devel
Depends: gnat, gnat-4.6, ${shlibs:Depends}, ${misc:Depends}
Description: Ada Semantic Interface Specification (ASIS) example programs
 ASIS (Ada Semantic Interface Specification) lets you develop applications
 to walk through the sources of your Ada programs and examine the semantic
 constructs.
 .
  * asistant is an interactive command-line tool to explore the ASIS parse tree
    of a program.
  * gnatcheck verifies the conformance of source text to coding conventions
  * gnatelim finds out unused subprograms and eliminates them.
  * gnatmetric calculates metrics such as code complexity.
  * gnatpp is a pretty-printer which reformats Ada source text according to
    a default or user-specified style guide.
  * gnatstub generates an empty but compilable body for a given specification.
  * gnatsync analyzes multitasking programs to find possible race conditions.

Package: libasis2010
Architecture: any
Section: libs
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: gnat, gnat-4.6, ${shlibs:Depends}, ${misc:Depends}
Description: Ada Semantic Interface Specification (ASIS) runtime library
 ASIS (Ada Semantic Interface Specification) lets you develop applications
 to walk through the sources of your Ada programs and examine the semantic
 constructs.
 .
 This package contains the libraries necessary to execute ASIS programs.

Package: libasis2010-dbg
Architecture: any
Multi-Arch: same
Section: debug
Priority: extra
Depends: ${ada:Depends}, ${misc:Depends}
Recommends: ${ada:Recommends}
Suggests: ${ada:Suggests}
Description: Ada Semantic Interface Specification (ASIS) runtime library - debugging symbols
 ASIS (Ada Semantic Interface Specification) lets you develop applications
 to walk through the sources of your Ada programs and examine the semantic
 constructs.
 .
 This package contains the symbols necessary to debug ASIS programs using gdb.

Package: asis-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Suggests: gnat
Description: Ada Semantic Interface Specification (ASIS) documentation
 ASIS (Ada Semantic Interface Specification) lets you develop applications
 to walk through the sources of your Ada programs and examine the semantic
 constructs.
 .
 This package contains the documentation in HTML, info, PDF and plain text
 formats.

=== debian/rules ===
#! /usr/bin/make -rf
# Debian build script for asis
# Copyright (c) 2003-2009 Ludovic Brenta <lbrenta@debian.org>
# Copyright (c) 2013      Nicolas Boulenguez <nicolas@debian.org>

# This build script is free software; you can redistribute it and/or
# modify it under terms of the GNU General Public License as published
# by the Free Software Foundation; either version 2, or (at your
# option) any later version. This build script is distributed in the
# hope that it will be useful, but WITHOUT ANY WARRANTY; without even
# the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
# PURPOSE.  See the GNU General Public License for more details. You
# should have received a copy of the GNU General Public License
# distributed with this build script; see file
# /usr/share/common-licenses/GPL. If not, write to the Free Software
# Foundation, 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

# Uncomment this to turn on verbose mode. 
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

include /usr/share/dpkg/default.mk
include /usr/share/ada/debian_packaging.mk
ADAFLAGS += -gnatafno -gnatwa -gnatVa
ADAFLAGS_no_opt := $(subst -O2,-O0,$(ADAFLAGS))
ADAFLAGS_style := $(subst -gnatfnoy,-gnatfno,$(ADAFLAGS))

# Generate the -X options for gnatmake.
X_flags = $(foreach v,$(1),"-X$(v)=$($(v))")

aliversion := $(shell sed -n -e "s/^Package: libasis\([[:digit:]]\+-dev\)$$/\1/p" debian/control)
ifndef aliversion
  $(warning Could not guess aliversion from debian/control)
endif
soversion := $(shell sed -n -e "s/^Package: libasis\([[:digit:]]\+\)$$/\1/p" debian/control)
ifndef soversion
  $(warning Could not guess soversion from debian/control)
endif

mtnbase := base_debian.db
mtnversion := af45f0024c1a910bdd57055a7b2a1834380c9aa8
branch := com.adacore.asis.debian
orig_dir := asis_$(aliversion).orig
orig_tgz := asis_$(aliversion).orig.tar.gz

######################################################################
POLICY_TARGETS := binary binary-arch binary-indep build build-arch \
  build-indep clean
.PHONY: $(POLICY_TARGETS)
$(POLICY_TARGETS):
	dh $@ --with ada-library

# Ignore upstream Makefile.
override_dh_auto_configure:
override_dh_auto_build-arch::
override_dh_auto_build-indep:
override_dh_auto_test:
override_dh_auto_install:
override_dh_auto_clean::

######################################################################
get-orig-source:
	if [ ! -e ../$(mtnbase) ]; then \
		mtn -d../$(mtnbase) db init; \
	fi; \
	mtn -d../$(mtnbase) -k "" pull www.ada-france.org '$(branch)'; \
	cd .. && \
	mtn -d$(mtnbase) co -r$(mtnversion) -b$(branch) $(orig_dir) && \
	rm -rf $(orig_dir)/_MTN $(orig_dir)/.*ignore&& \
	tar czf $(orig_tgz) $(orig_dir) && \
	rm -r $(orig_dir)

######################################################################
# Build dynamic and static versions of the library.
LIB_PROJECT := debian/install_asis

define for_kind_in_dynamic_static_loop
  override_dh_auto_build-arch::
	gnatmake $(BUILDER_OPTIONS) -P$(LIB_PROJECT).gpr \
          $(call X_flags, ADAFLAGS ADAFLAGS_no_opt KIND LDFLAGS soversion)
  override_dh_auto_clean::
	rm -f $(LIB_PROJECT)_lib_$(KIND)/* $(LIB_PROJECT)_obj_$(KIND)/*
endef
$(foreach KIND,dynamic static,$(eval $(for_kind_in_dynamic_static_loop)))

######################################################################
# Import the dynamic version of the library and build each tool.
TOOLS := asistant gnatcheck gnatelim gnatmetric gnatpp gnatstub gnatsync
TOOLS_PROJECT := debian/tools

define for_tool_in_tools_loop
  override_dh_auto_build-arch::
	gnatmake $(BUILDER_OPTIONS) -P$(TOOLS_PROJECT).gpr -XKIND=dynamic \
          $(call X_flags,ADAFLAGS ADAFLAGS_no_opt ADAFLAGS_style LDFLAGS \
                         soversion tool)
  override_dh_auto_clean::
	rm -f $(TOOLS_PROJECT)_obj_$(tool)/*
  override_dh_install-arch::
	dh_install --package=asis-programs $(TOOLS_PROJECT)_obj_$(tool)/$(tool) usr/bin
	dh_installman --package=asis-programs debian/$(tool).1
endef
$(foreach tool,$(TOOLS),$(eval $(for_tool_in_tools_loop)))

######################################################################
# Documentation

override_dh_auto_build-indep:
	$(MAKE) -C documentation
override_dh_auto_clean::
	$(MAKE) -C documentation clean
override_dh_install-indep:
	dh_install --indep
	dh_installdocs --package=asis-doc $(foreach e,html pdf txt,documentation/*.$(e))
	dh_installinfo --package=asis-doc documentation/*.info
	cp tools/gnatmetric/README \
		debian/asis-doc/usr/share/doc/asis-doc/README.gnatmetric
	cp tools/gnatpp/README \
		debian/asis-doc/usr/share/doc/asis-doc/README.gnatpp
	cp tools/gnatsync/README \
		debian/asis-doc/usr/share/doc/asis-doc/README.gnatsync

######################################################################
override_dh_install-arch::
	dh_install --arch

######################################################################

RUN_TESTS_TMP := libasis-run-tests-XXXXXXXXXX

run-tests:
	ADTTMP=`mktemp --tmpdir --directory $(RUN_TESTS_TMP)` && \
        ADTTMP=$$ADTTMP sh debian/tests/link-with-shared 2> $$ADTTMP/stderr; \
        status=$$?; cat $$ADTTMP/stderr; \
        if test $$status != 0; then \
          echo "Test failed: non zero exit status ($$status)."; \
        elif test -s $$ADTTMP/stderr; then \
          echo "Test failed: activity on stderr."; \
        fi; \
        rm -f -r $$ADTTMP

=== debian/watch ===
# The upstream tarball download system is too complicated to be
# described in a watch file. Asis may be found in the GNAT GPL section
# of the Homepage URL in debian/control.
